--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    15:59:32 05/17/06
-- Design Name:    
-- Module Name:    switch - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity switch is
    Port ( clk : in std_logic;
           reset : in std_logic;
           addr : in std_logic_vector(5 downto 0);
           data : inout std_logic_vector(19 downto 0);
           req : in std_logic;
           ready : out std_logic;
           fifo_r : in std_logic_vector(19 downto 0);
           fifo_r_req : out std_logic;
           fifo_w : out std_logic_vector(19 downto 0);
           fifo_w_req : out std_logic;
           fifo_r_empty : in std_logic;
           fifo_w_full : in std_logic);
end switch;

architecture Behavioral of switch is

begin
data<=fifo_r when addr="111100" else 
      (others=>'Z');
fifo_w<=data when addr="111101" ;

fifo_w_req<= req when addr="111101" else '0';
fifo_r_req<= req when addr="111100" else '0';


ready<='Z' ;--when (addr="111100" and fifo_r_empty='0') or( addr="111101" and fifo_w_full='0') else
--		 'Z';

end Behavioral;
