--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    15:32:47 07/25/06
-- Design Name:    
-- Module Name:    ddl - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ddl is
	PORT
	(
		fbD			: INOUT	STD_LOGIC_VECTOR(31 downto 0) ;
		fbCTRL_N	: INOUT	STD_LOGIC ;
		fbTEN_N		: INOUT	STD_LOGIC ;

		fiDIR		: out STD_LOGIC ;
		fiBEN_N		: out STD_LOGIC ;
		fiLF_N		: out STD_LOGIC ;

		foBSY_N		: in STD_LOGIC ;
		foCLK		: in STD_LOGIC;
--avalon
	ava_clk : in std_logic ;
	ava_cs : in std_logic ;

	ava_wdata : in std_logic_vector(31 downto 0) ;
	ava_rdata : out std_logic_vector(31 downto 0) ;
	
	ava_write_n : in std_logic ;
	ava_addr : in std_logic_vector(5 downto 0) );
end ddl;

architecture Behavioral of ddl is
component myfifo
	PORT
	(
		data		: IN STD_LOGIC_VECTOR (19 DOWNTO 0);
		wrreq		: IN STD_LOGIC ;
		rdreq		: IN STD_LOGIC ;
		rdclk		: IN STD_LOGIC ;
		wrclk		: IN STD_LOGIC ;
		aclr		: IN STD_LOGIC  := '0';
		q		: OUT STD_LOGIC_VECTOR (19 DOWNTO 0);
		rdempty		: OUT STD_LOGIC ;
		wrfull		: OUT STD_LOGIC 
	);
end component;

begin


end Behavioral;
