--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:    19:56:55 04/24/06
-- Design Name:    
-- Module Name:    writedeligater - Behavioral
-- Project Name:   
-- Target Device:  
-- Tool versions:  
-- Description:
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
--------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity writedeligater is
    Port ( 
		 	reset_n : in std_logic ;
			 clk : in std_logic;
           trg_come : in std_logic;
           fifo_select : out std_logic_vector(4 downto 0);
           idle_state : in std_logic_vector(4 downto 0));
end writedeligater;

architecture Behavioral of writedeligater is


begin

 -------------------------------------------------------------------------------------------
sm0:process(clk, trg_come, reset_n)
begin
  if  reset_n='0' then
fifo_select<="00000";
 else
if  clk='1'and clk'last_value='0' then		 --a fifo_select comes, set a bit of idle
  if trg_come='1' then
	  if idle_state(0)='1' then
	  fifo_select(0)<='1';
	
	   elsif	idle_state(1)='1' then
	  fifo_select(1)<='1';

	   elsif	idle_state(2)='1' then
	  fifo_select(2)<='1';

	   elsif	idle_state(3)='1' then
	  fifo_select(3)<='1';

	   elsif	idle_state(4)='1' then
	  fifo_select(4)<='1';

	  end  if;
	else
		if idle_state(0)='0' then
	  fifo_select(0)<='0';
	  end if;

	   if	idle_state(1)='0' then
	  fifo_select(1)<='0';
	  end if;

		if	idle_state(2)='0' then
	  fifo_select(2)<='0';
 	  end if;

		if	idle_state(3)='0' then
	  fifo_select(3)<='0';
	  end if;

		if	idle_state(4)='0' then
	  fifo_select(4)<='0';
	  end if;

	end if;

	 
 end if;
    end if;
end process;
----------------------------------------------------------------------------------------------

end Behavioral;
